Bug 1132402 - [RFE] Support Facter 2 structured facts
Summary: [RFE] Support Facter 2 structured facts
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Satellite
Classification: Red Hat
Component: Fact
Version: 6.0.4
Hardware: Unspecified
OS: Unspecified
unspecified
low
Target Milestone: Unspecified
Assignee: satellite6-bugs
QA Contact: Sebastian Gräßl
URL: http://projects.theforeman.org/issues...
Whiteboard:
: 1401123 (view as bug list)
Depends On:
Blocks: 1132363
TreeView+ depends on / blocked
 
Reported: 2014-08-21 09:47 UTC by Stephen Benjamin
Modified: 2019-08-12 14:02 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-02-21 12:28:04 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Foreman Issue Tracker 4528 0 Normal Closed Support Facter 2 structured facts 2020-02-19 18:37:12 UTC
Red Hat Product Errata RHSA-2018:0336 0 normal SHIPPED_LIVE Important: Satellite 6.3 security, bug fix, and enhancement update 2018-02-21 22:43:42 UTC

Description Stephen Benjamin 2014-08-21 09:47:58 UTC
Facter 2 is at RC1, and while it has no structered facts by default, it will have in the future, and people will start writing their own probably even sooner.

I quickly looked into this using the foreman_chef plugin. I came up with this:

1. Add 'plainify' and 'get_key' to node.rb from chef_foreman_handler, and change 'build_body' to call:

    {'facts' => plainify(puppet_facts['values'].merge({:_type => 'foreman_chef'})).flatten.inject(&:merge), 'name' => hostname, 'certname' => certname}

2. Add foreman_chef plugin to Foreman
3. Fix https://github.com/theforeman/foreman/blob/develop/app/services/fact_importer.rb#L79 to not drop Integers
4. (optional) Handle changes of fact type. Currently if you upload "foo: bar" and then upload "foo: { "bar" => "quux" }" it won't display properly due to the old string-type fact in the db.

We'll probably want to move the hash-handling code out of foreman_chef and into core. I'd also consider investigating the way we compress and uncompress the facts hash with '::' vs just sending/parsing the whole hash directly.

Comment 1 Stephen Benjamin 2014-08-21 09:48:00 UTC
Created from redmine issue http://projects.theforeman.org/issues/4528

Comment 3 Dominic Cleal 2014-08-21 10:00:18 UTC
This is referring to the ability to store, view and use structured facts in the web UI under Monitor > Facts.

Comment 5 Bryan Kearney 2015-08-25 18:07:00 UTC
Upstream bug component is Fact

Comment 6 Bryan Kearney 2016-07-06 16:03:02 UTC
Moving to POST since upstream bug http://projects.theforeman.org/issues/4528 has been closed

Comment 9 Josh Foots 2016-12-16 18:51:53 UTC
*** Bug 1401123 has been marked as a duplicate of this bug. ***

Comment 10 Sebastian Gräßl 2017-08-09 12:29:54 UTC
Verified on Satellite - 6.3.0 snap 10.

Structured Facts are imported (converting the the value to a string)

Comment 13 errata-xmlrpc 2018-02-21 12:28:04 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:0336


Note You need to log in before you can comment on or make changes to this bug.